#ifndef BTREE_MEM_H_
#define BTREE_MEM_H_


struct btree_mem_node;

struct btree_mem
   {
   int mindeg;
   struct btree_mem_node * root;
   int (*cmp)(void *, void *);
   };

struct btree_mem * btree_mem_new(int min_degree, int (*cmp)(void *, void *));
void btree_mem_delete(struct btree_mem * bt);

void * btree_mem_insert(struct btree_mem * bt, void * key, void * data);
void * btree_mem_find(struct btree_mem * bt, void * key);
void * btree_mem_remove(struct btree_mem * bt, void * key);

#endif
